﻿
namespace WP7Host.Web
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Data.Objects.DataClasses;
    using System.Linq;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;


    // The MetadataTypeAttribute identifies WP7HistoryMetadata as the class
    // that carries additional metadata for the WP7History class.
    [MetadataTypeAttribute(typeof(WP7History.WP7HistoryMetadata))]
    public partial class WP7History
    {

        // This class allows you to attach custom attributes to properties
        // of the WP7History class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class WP7HistoryMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private WP7HistoryMetadata()
            {
            }

            public string Action { get; set; }

            public string Code { get; set; }

            public int Id { get; set; }

            public DateTime RegDT { get; set; }

            public DateTime UptDT { get; set; }

            public bool UseBT { get; set; }

            public WP7UriList WP7UriList { get; set; }

            public int WP7UriListId { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies WP7UriListMetadata as the class
    // that carries additional metadata for the WP7UriList class.
    [MetadataTypeAttribute(typeof(WP7UriList.WP7UriListMetadata))]
    public partial class WP7UriList
    {

        // This class allows you to attach custom attributes to properties
        // of the WP7UriList class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class WP7UriListMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private WP7UriListMetadata()
            {
            }

            public string ChannelUri { get; set; }

            public int Id { get; set; }

            public DateTime RegDT { get; set; }

            public DateTime UptDT { get; set; }

            public bool UseBT { get; set; }

            public string UserName { get; set; }

            //연결데이터 함께 조회
            [Include]
            public EntityCollection<WP7History> WP7History { get; set; }
        }
    }
}
