﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using WP7Host.Models;
using Microsoft.Expression.Interactivity.Core;
using System.ComponentModel;
using System.Threading;

namespace WP7Host.ViewModels
{
    public class MainPageViewModel : INotifyPropertyChanged
    {
        /// <summary>
        /// PropertyChanged Event
        /// </summary>
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected void FirePropertyChanged(string PropertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                if (Deployment.Current.Dispatcher != null &&
                    !Deployment.Current.Dispatcher.CheckAccess())
                {
                    Deployment.Current.Dispatcher.BeginInvoke
                        (
                            (ThreadStart)(
                            () => handler(this, new PropertyChangedEventArgs(PropertyName))
                            )
                        );
                }
                else
                {
                    handler(this, new PropertyChangedEventArgs(PropertyName));
                }
            }
        }

        #endregion

        //모델
        public WP7Model Model { get; set; }

        private string messageData;
        /// <summary>
        /// 메세지 데이터
        /// </summary>
        public string MessageData
        {
            get { return messageData; }
            set
            {
                if (messageData != value && value != null)
                {
                    messageData = value;
                    FirePropertyChanged("MessageData");
                }
            }
        }

        //생성자
        public MainPageViewModel()
        {
            Model = new WP7Model();
        }

        private ICommand addCommand;
        /// <summary>
        /// 추가 커맨드
        /// </summary>
        public ICommand AddCommand
        {
            get
            {
                if (addCommand == null)
                {
                    addCommand = new ActionCommand(() =>
                    {
                        MessageData = "지원하지 않는 명령입니다.";
                    }
                    );
                }
                return addCommand;
            }
        }
        private ICommand cancelCommand;
        /// <summary>
        /// 취소 커맨드
        /// </summary>
        public ICommand CancelCommand
        {
            get
            {
                if (cancelCommand == null)
                {
                    cancelCommand = new ActionCommand(() =>
                    {
                        MessageData = "지원하지 않는 명령입니다.";
                    });
                }
                return cancelCommand;
            }
        }

        private ICommand removeCommand;
        /// <summary>
        /// 삭제 커맨드
        /// </summary>
        public ICommand RemoveCommand
        {
            get
            {
                if (removeCommand == null)
                {
                    removeCommand = new ActionCommand(item =>
                    {
                        MessageData = "지원하지 않는 명령입니다.";
                    });
                }
                return removeCommand;
            }
        }

        private ICommand saveCommand;
        /// <summary>
        /// 저장 커맨드
        /// </summary>
        public ICommand SaveCommand
        {
            get
            {
                if (saveCommand == null)
                {
                    saveCommand = new ActionCommand(() =>
                    {
                        MessageData = "지원하지 않는 명령입니다.";
                    });
                }
                return saveCommand;
            }
        }

        private ICommand selectCommand;
        /// <summary>
        /// 조회 커맨드 
        /// </summary>
        public ICommand SelectCommand
        {
            get
            {
                if (selectCommand == null)
                {
                    selectCommand = new ActionCommand(() =>
                    {
                        //조회 함수 호출
                        Model.Getting(null, this);
                    });
                }
                return selectCommand;
            }
        }

        private ICommand loadedCommand;
        public ICommand LoadedCommand
        {
            get
            {
                if (loadedCommand == null)
                {
                    loadedCommand = new ActionCommand(() =>
                    {
                    });
                }
                return loadedCommand;
            }
        }
    }
}
